# Modern Winver
A modern and more functional replacement for the About Windows screen powered by UWP and RegistryRT, providing details on Windows and your PC.

![ModernWinver](https://cdn.discordapp.com/attachments/272509873479221249/930417627329875988/0.png) 

## Current Features
 - Provides information on your current installation of Windows
 - Gives you a quick overview of core system specs and resource usage
 - Presents quick access to view and change your current wallpaper, lock screen and accent colour
 - Designed for Windows 11, compatible with Windows 10.
 - Launchable from a browser or the Run prompt with `mwv:`

## Planned Features
 - More system details
 - Rearrange page layout
 - Write, add and share custom pages
 - More appearance options
 - The ability to launch more pages with the `mwv:` URI

## Installation
You can download the latest release of Modern Winver on the Microsoft Store [here](https://www.microsoft.com/p/ModernWinver/9ND14WHFRGSX).

Alternatively, you can download the latest release from GitHub and install it manually.
1) Download the ZIP file from the Releases tab.
2) Extract the ZIP into a folder.
3) Enable Developer Mode in Settings
4) Open PowerShell, and run the Install.ps1 script.

## Notes
 - Modern Winver is still in development! There may be bugs, incompatibilities or incorrect information. Please file an issue if you run into problems.
 - Huge thanks to [@gus33000](https://github.com/gus33000) for developing RegistyRT.
 - Modern Winver is based on an old project by the same name, which you can find [here](https://github.com/torchgm/WpfModernWinver). It was built in WPF, and is only designed for Windows 10. It's unsupported now but you're welcome to check it out if you're interested.
